<?php 
function bp_universal_profile_redirect_catch_uri() {
	// Allow for internationalization.
	$me_string = __( 'me', 'buddypress' );
	// Or direct filtration.
	$me_string = apply_filters( 'bp_universal_user_profile_slug', $me_string );

	// Catch URIs that start with the 'me string' and redirect to the user's profile.
	if ( strpos( $_SERVER['REQUEST_URI'], '/' . $me_string . '/' ) === 0 ) {

		if ( $current_user_id = get_current_user_id() ) {
			// For logged-in users, we replace '/myprofile/' and send them to their user domain.
			$target = bp_loggedin_user_domain() . str_replace( '/' . $me_string . '/', '', $_SERVER['REQUEST_URI'] );
		} else {
			// If the user is not logged in, we send them to login screen
			// with the redirect args set to return them here. Then, case #1 kicks in.
			$target = wp_login_url( ( is_ssl() ? 'https://' : 'http://' ) .  $_SERVER["HTTP_HOST"] . $_SERVER['REQUEST_URI'] );
		}

		bp_core_redirect( $target );
		exit;

	}
}
add_action( 'bp_init', 'bp_universal_profile_redirect_catch_uri', 9 );